{set font to Courier New, size 8}

{Date 11 Feb 1998, initial release 11 Feb 1998}

{RXLIB DEFINE}
{if RxLib is present then add $ to define on next line, ie $define....}
{DO NOT remove braces, see examples directly below}
{define rxLibinGL}

{$IFNDEF VER80}
 {$IFNDEF VER90}
  {$IFNDEF VER93}
    {$DEFINE GL_D3} { Delphi 3.0 or higher with Tsplitter control}
  {$ENDIF}
 {$ENDIF}
{$ENDIF}


unit panelinf;

interface

uses forms,controls, classes, extctrls,sysutils{$ifdef rxLibinGL},
	 rxsplit{$endif};

type
	DefglPiOptions = (piType,piAlignment,piSiblings,piRxInfo);
	TglPiOptions=set of DefglPiOptions;

type TSplitterOptions=(piInclude,piExclude);

const
glAlignment: array[alNone..alClient] of string=(
'alNone','alTop','alBottom','alLeft', 'alRight', 'alClient');

const
minIndent=1;
maxIndent=10;

type
TGlPanelinfo=class(TComponent)
   private

   	FstrList : Tstringlist;
       Foptions : TglPiOptions;
       Findent : string;
       FsplitterOpts : TsplitterOptions;

       siblingNumber : integer;

       function getIndent:integer;
       procedure setIndent(i : integer);
       function createDepthedString(s : string; i : integer):string;
       function hasPanels(p : Twincontrol):boolean;

   protected

       procedure setstrings(s : Tstringlist);virtual;
       function readStrings:TstringList;virtual;
       function getPanelInfo(f : Tform; s : Tstringlist):Tstringlist;virtual;
       procedure processPanel(p : twincontrol;strlist : tstringlist;
       	depth : integer); virtual;
       procedure processWincontrol(p : twincontrol;strlist : tstringlist;
       	depth : integer); virtual;

       function createString(depth : integer;siblingString,name,alignString,
       	typeString: string):string;

   public

		constructor Create(AOwner: TComponent); override;
		destructor destroy;override;

		procedure refresh;

  published

  		property Panelling : Tstringlist read readStrings write setstrings
       	stored false;
       property Options : TglPiOptions read Foptions write Foptions;
       property Indent : integer read getIndent write setIndent;
       property Splitters : TsplitterOptions read Fsplitteropts
       	write Fsplitteropts;

end;


procedure Register;



implementation

function getAlignName(a : Talign):string;forward;

{recursive function}
procedure TGlPanelinfo.processPanel(p : twincontrol; strlist : Tstringlist;
	depth : integer);
var
	cntr, siblingNum : integer;
   rxInfoString,  typeString,
   siblingString, AlignString : string;
begin
	inc(depth);

   {following 4 lines ensure that sibling numbering increments properly}
   if (p.controlcount=0) then
	   exit;

	{further sibling number management}
   if p is TcustomPanel then
	   inc(siblingNumber);

   siblingNum:=siblingNumber;

  	for cntr:=0 to p.controlcount-1 do begin

       if p.controls[cntr]=nil then
           continue;
       if not (p.controls[cntr] is Twincontrol) then
	           continue;

       rxInfoString:='';
       typeString:='';
       siblingString:='';
       AlignString:='';


       {$ifdef rxLibinGL} {for rxlib splitter}
       if p.controls[cntr] is TrxSplitter then begin
       	if FSplitterOpts=piExclude then continue;
           with p.controls[cntr] as TrxSplitter do begin

               if piRxInfo in Foptions then begin
                   if controlfirst<>nil then
                       rxInfoString:='  {1st:'+controlfirst.name+'}';
                   if controlsecond<>nil then
                       rxInfoString:='  {2nd:'+controlsecond.name+'}';
               end;

               if piAlignment in FOptions then
                   alignString:=getAlignName(align);
               if piType in Foptions then
                   typeString:=className;
               if piSiblings in Foptions then
                   siblingString:=intToStr(siblingNum);

               strlist.add(createString(depth,siblingString,name,alignString,
               	typeString)+rxInfoString);
           end;{with}
           processpanel(twincontrol(p.controls[cntr]),strlist,depth);
           continue;
       end;
       {$endif}

       {$ifdef gl_d3} {For delphi3 Tsplitter}
       if p.controls[cntr] is TSplitter then begin
         	if  FSplitterOpts=piExclude then continue;
           with p.controls[cntr] as TSplitter do begin

               if piAlignment in FOptions then
                   alignString:=getAlignName(align);
               if piType in Foptions then
                   typeString:=className;
               if piSiblings in Foptions then
                   siblingString:=intToStr(siblingNum);

               Fstrlist.add(createString(depth,siblingString,name,alignString,
               	typeString));
           end;{with}
           processpanel(twincontrol(p.controls[cntr]),strlist,depth);
           continue;
       end;
       {$endif}

       {for custompanels with "split" in the classname}
       if (p.controls[cntr] is tcustompanel) and
       	(pos('split',lowercase(p.controls[cntr].classname))>0) then begin
       	if  FSplitterOpts=piExclude then continue;
           with p.controls[cntr] as Tcustompanel do begin

               if piAlignment in FOptions then
                   alignString:=getAlignName(align);
               if piType in Foptions then
                   typeString:=className;
               if piSiblings in Foptions then
                   siblingString:=intToStr(siblingNum);

               strlist.add(createString(depth,siblingString,name,alignString,
               	typeString));
           end;{with}
           processpanel(twincontrol(p.controls[cntr]),strlist,depth);
           continue;
       end;



       {basic panel}
		if (p.controls[cntr] is tpanel) and
       	(p.controls[cntr].classname='TPanel') then begin
          	with p.controls[cntr] as Tpanel do begin

               if piAlignment in FOptions then
                   alignString:=getAlignName(align);
               if piSiblings in Foptions then
                   siblingString:=intToStr(siblingNum);
               {UNCOMMENT FOR piType CONSISTENCY}
               {if piType in Foptions then
                   typeString:=className;}

	       		strlist.add(createString(depth,siblingString,name,alignString,
               	typeString));
           end;{with}
           processpanel(twincontrol(p.controls[cntr]),strlist,depth);
           continue;
       end;

      {for custompanels, reason why this comes last is that splitters are also
      custompanels}
		if p.controls[cntr] is tcustompanel then begin
          	with p.controls[cntr] as Tcustompanel do begin

                   if piAlignment in FOptions then
                   	alignString:=getAlignName(align);
                   if piType in Foptions then
                   	typeString:=className;
                   if piSiblings in Foptions then
                   	siblingString:=intToStr(siblingNum);

					strlist.add(createString(depth,siblingString,name,
                   	alignString,typeString));
           end;{with}
           processpanel(twincontrol(p.controls[cntr]),strlist,depth);
           continue;
       end;

       {if is not TCustomPanel or Tsplitter based then it may still contain
       something}
       if p.controls[cntr] is Twincontrol then begin
       	processWinControl(twincontrol(p.controls[cntr]),Fstrlist,depth);
       end;

   end; {for}
end;

{for non-TcustomPanel based controls derived from Twincontrol}
procedure TGlPanelinfo.processWinControl( p :  twincontrol;strlist : tstringlist;
       	depth : integer);
var cntr : integer;
begin
	if p.controlcount=0 then
   	exit;

	if hasPanels(p) then begin
       FstrList.add(createDepthedString(Findent,depth)+'<'+p.name+'>');
       processpanel(p,FstrList,depth);
   end
   else begin
   	for cntr:=0 to p.controlCount-1 do begin
       	if p.controls[cntr]=nil then continue;
       	if p.controls[cntr] is TWinControl then
           	processWinControl(TwinControl(p.controls[cntr]),FstrList,depth);
       end;
   end;

end;

function TGlPanelinfo.createDepthedString(s : string; i : integer):string;
var cntr : integer;
str : string;
begin
	str:='';
	for cntr:=0 to i-1 do
   	str:=str+s;
   result:=str;
end;

{glAlignment in function for clarity only}
function getAlignName(a : Talign):string;
begin
	result:=glAlignment[a];
end;

function TGlPanelinfo.getPanelInfo(f : Tform; s : Tstringlist):Tstringlist;
begin
	processpanel(twincontrol(f),s,0);
   result:=s;
end;


constructor TGlPanelinfo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FstrList:=TstringList.create;
  Foptions:=[piAlignment{$ifdef gldebug},piType,piSiblings{$endif}];
  FSplitterOpts:=piInclude;
  Findent:='    ';

end;


function TglPanelInfo.readStrings:TstringList;
begin
	result:=FstrList;
   if (csDesigning in ComponentState) or (Fstrlist.count=0) then
       refresh;

end;


procedure TglPanelInfo.refresh;
begin

	FstrList.clear;
   siblingNumber:=0;

  {classname, instead of name, due to D1 bug}
  FstrList.add(Tform(owner).classname);
  getPanelInfo(TForm(owner),FstrList);
end;

procedure TglPanelInfo.setstrings(s : Tstringlist);
begin
{do nothing}
   if not (csDesigning in ComponentState) then
   	raise exception.create('Cannot assign to this property');
end;

{The format of the output is determined by this function}
function TglPanelInfo.createString(depth : integer;siblingString,name,
	alignString,typeString:string):string;
var
	p,a,t : string;

begin

	p:='';
	a:='';
   t:='';

   if siblingString<>'' then
   	p:=siblingString+': ';
   if alignString<>'' then
   	a:='  {'+alignString+'}';
   if typeString<>'' then
   	t:='  {'+typeString+'}';

	result:=createDepthedString(Findent,depth)+p+name+a+t;
end;


function TglPanelInfo.getIndent:integer;
begin
	result:=length(Findent);
end;

procedure TglPanelInfo.setIndent(i : integer);
var
	str : string;
   cntr : integer;
begin
	if i<minIndent then i:=minIndent;
   if i>maxIndent then i:=maxIndent;

	str:='';
   for cntr:=0 to i-1 do begin
   	str:=str+' ';
   end;
   Findent:=str;
end;

function TglPanelInfo.hasPanels(p : Twincontrol):boolean;
var
	cntr : integer;
begin
   result:=false;
	for cntr:=0 to p.controlcount-1 do begin
   	if p.controls[cntr]=nil then
       	continue;
   	if p.controls[cntr] is TcustomPanel then begin
       	result:=true;
           exit;
       end;
   end;
end;


destructor TglPanelInfo.destroy;
begin

	FstrList.free;
   FstrList:=nil;

	inherited destroy;
end;

procedure Register;
begin
  RegisterComponents('Custom', [TGlPanelinfo]);
end;

end.

